// C Source File
// Created 13/12/2002; 18:37:35

#define USE_TI89              // Compile pour TI-89
#define USE_TI92PLUS					// Compile pour TI-92/92+
#define USE_V200              // Compile pour V200
#define OPTIMIZE_ROM_CALLS    // Utilise l'optimisation de la ROM Call ?
#define NO_EXIT_SUPPORT       // Les instructions 'exit' et 'atexit' ne peuvent ainsi plus fonctionner et a fait encore gagner de la place !
#define MIN_AMS 100           // Compile pour Advanced Mathematics Software 1.00 ou plus

#include <tigcclib.h>         // Inclus toutes les librairies

#include "initialise.h"
#include "clavier.h"
#include "images.h"
#include "graphiques.h"
#include "divers.h"
#include "menus.h"
#include "niveaux.h"


//////////////////////////////////////////////////////////////////////////////////////
//                  			Fonction du jeu proprement dit														//
//////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////

void jeu(void)
{	
	char extension[] = "TEMP"; // Extension de la variable de sauvegarde lors d'une 'QUICK_EXIT_SAVE'
		
	unsigned char x_qu[100] = {};
  unsigned char y_qu[100] = {};
  short i;
	short x_coeff;
	short y_coeff;
	short x_tet;
  short y_tet;
  short long_qu;
	short compteur;
	short bonus;
	short allonge;
	short fantome;
	short pom;
	unsigned short score;
	short vie;
	short nivo;
	short x_temps;
	short compteur_t;
	short flag;
	flag = 0;

	if(!QUICK_EXIT_SAVE)
	{
		score = 0;
		vie = 3;
	  nivo = ordre == 0? 0: random(11);
	}

	Debut:
	
	if(!QUICK_EXIT_SAVE)
	{
		bonus = 0;
		pom = 0;
		compteur = 0;
		fantome = 1;
		allonge = 0;
		long_qu = 4;
		x_temps = 157;
		compteur_t = 0;
		x_qu[0] = 4;
		x_qu[1] = 4;
		x_qu[2] = 4;
		x_qu[3] = 4;
		x_qu[4] = 4;
		y_qu[0] = 3;
		y_qu[1] = 3;
		y_qu[2] = 3;
		y_qu[3] = 3;
		y_qu[4] = 3;
		x_coeff = 4;
		y_coeff = 0;
		x_tet = 4;
		y_tet = 3;
	
		if(!flag)
		 fade_down(1);
		fill_rect(0, 92, 159, 99, 0, GRIS_CLAIR);
		fill_rect(0, 92, 159, 99, 0, GRIS_FONCE);
		draw_rect(1, 0, 158, 93, 4, GRIS_CLAIR);
		draw_rect(2, 1, 157, 92, 4, GRIS_FONCE);
		draw_rect(3, 2, 156, 91, 4, GRIS_FONCE);
		draw_rect(3, 2, 156, 91, 4, GRIS_CLAIR);
		fill_rect(1, 93, 158, 99, 4, GRIS_CLAIR);
		sprite8_GRIS(1, 93, vie_0, vie_1);
		draw_line(2, 92, 157, 92, 4, GRIS_CLAIR);
		draw_num(9, 94, ":%02d", vie, 4, GRIS_FONCE, PETIT);
		draw_num(27, 94, "Apples:%02d/12", pom, 4, GRIS_FONCE, PETIT);
		draw_num(79, 94, "Score:%05u", score, 4, GRIS_FONCE, PETIT);
		draw_num(130, 94, "Level:%02d", nivo, 4, GRIS_FONCE, PETIT);	
	
		draw_nivo(nivo, flag);
	
		if(!flag)
		 fade_up();
		fill_rect(4, 3, 7, 6, 2, GRIS_FONCE);
		disp_nivo(nivo, vie);
		disp_pom();
	
		do
		{
			get_key(1);
		}while(!BAS && !DROITE && !ESCAPE);
	
		if(BAS)
		{
			x_coeff = 0;
			y_coeff = 4;
		}
		else if(ESCAPE)
		{
			disp_quit(&vie);
		}	 
	}
	else
	{
		flag = 1;
		memcpy(&x_qu, Sauvegarde+7682, 100);
		memcpy(&y_qu, Sauvegarde+7782, 100);
		x_coeff = *(unsigned short *)(Sauvegarde+7882);
		y_coeff = *(unsigned short *)(Sauvegarde+7884);
		x_tet = *(unsigned short *)(Sauvegarde+7886);
		y_tet = *(unsigned short *)(Sauvegarde+7888);
		long_qu = *(unsigned short *)(Sauvegarde+7890);
		compteur = *(unsigned short *)(Sauvegarde+7892);
		bonus = *(unsigned short *)(Sauvegarde+7894);
		allonge = *(unsigned short *)(Sauvegarde+7896);
		fantome = *(unsigned short *)(Sauvegarde+7898);
		pom = *(unsigned short *)(Sauvegarde+7900);
		score = *(unsigned short *)(Sauvegarde+7902);
		vie = *(unsigned short *)(Sauvegarde+7904);
		nivo = *(unsigned short *)(Sauvegarde+7906);
		x_temps = *(unsigned short *)(Sauvegarde+7908);
		compteur_t = *(unsigned short *)(Sauvegarde+7910);
		x_pom = *(unsigned short *)(Sauvegarde+7912);
		y_pom = *(unsigned short *)(Sauvegarde+7914);
		x_bonus = *(unsigned short *)(Sauvegarde+7916);
		y_bonus = *(unsigned short *)(Sauvegarde+7918);
		dissolve_LCD(Sauvegarde+2, Sauvegarde+2+LCD_SIZE);
		disp_quit(&vie);
		QUICK_EXIT_SAVE = 0;
	}
	

	do
	{
		
		if(random(vitesse+7) == 5 && compteur == 0)
		{
			bonus = random(10);
			switch(bonus)
			{
				case 0:             // + 1 vie
				if(random(10) != 5)
				 break;
				compteur ++;		      
			  disp_bonus(bonus);
			  break;
			  case 1:             // - 1 vie
			  if(random(10) != 5)
			   break;
			  compteur ++;		      
			  disp_bonus(bonus);
			  break;
			  case 2:             // + 25 points
			  if(random(7) != 5)
			   break;
			  compteur ++;		      
			  disp_bonus(bonus);
			  break;
			  case 3:             // - 25 points
			  if(score < 25 || random(9) != 5)
			   break;
			  compteur ++;		      
			  disp_bonus(bonus); 
			  break;
			  case 4:             // + 50 points
			  if(random(8) != 5)
			   break;
			  compteur ++;		      
			  disp_bonus(bonus);
			  break;
			  case 5:             // + 100 points
			  if(random(9) != 5)
			   break;
			  compteur ++;		      
			  disp_bonus(bonus);
			  break;
			  case 6:             // Raccourcit la queue du serpent 
			  if(long_qu == 4 || random(9) != 5)
			   break;
			  compteur ++;		      
			  disp_bonus(bonus);
			  break;
			  case 7:             // Allonge la queue du serpent
			  if(long_qu+6*(13-pom) > 100 || random(9) != 5)
			   break;
			  compteur ++;		      
			  disp_bonus(bonus);
			  break;
			  case 8:             // Fantme !
			  if(fantome == 0 || random(13) != 5)
			   break;
			  compteur ++;		      
			  disp_bonus(bonus);
			  break;
			  case 9:            // Finit le niveau et passe au suivant
			  if(random(15) != 5)
			   break;
			  compteur ++;		      
			  disp_bonus(bonus);
			  break;
			}
		}
		
	 if(allonge == 0)
		{
			fill_rect(x_qu[0], y_qu[0], x_qu[0]+3, y_qu[0]+3, 2, GRIS_FONCE);
		  for(i = 0; i <= (long_qu-1); i ++)
		  {
		  	x_qu[i] = x_qu[i+1];
		  	y_qu[i] = y_qu[i+1];
		  }
		}
		else
		{
		 	allonge --;
		 	long_qu ++;
		}
			
		x_qu[long_qu] = x_tet;
		y_qu[long_qu] = y_tet;
		x_tet += x_coeff;
		y_tet += y_coeff;
		
		fill_rect(x_qu[long_qu], y_qu[long_qu], x_qu[long_qu]+3, y_qu[long_qu]+3, 2, GRIS_FONCE);
		
		if(ADAPT_x+x_qu[long_qu] == ADAPT_x+x_pom && ADAPT_y+y_qu[long_qu] == ADAPT_y+y_pom)
		{
			sprite8_GRIS(x_pom, y_pom, pom_0, pom_1);
	    pom ++;
	    score += (vitesse*2+5);
	    
	    if(pom == 12)
	    {
	    	nivo = ordre == 0? (nivo == 10? 0: nivo+1): random(11);
	    	vie ++;
	    	flag = 1;
	    	goto Debut;
	    }
	    
	    allonge = 6;
	    draw_num(51, 94, "%02d/12", pom, 4, GRIS_FONCE, PETIT);
	    draw_num(101, 94, "%05u", score, 4, GRIS_FONCE, PETIT);
	    x_temps += vitesse+1;
	    x_temps = x_temps >= 157? 157: x_temps;
	    draw_line(2, 92, x_temps, 92, 4, GRIS_FONCE);
	    draw_line(2, 92, x_temps, 92, 4, GRIS_CLAIR);
	    disp_pom();
		}
		
		if(compteur)
		{
			compteur ++;
			if(compteur == 43+vitesse*10 || (ADAPT_x+x_tet >= ADAPT_x+x_bonus && ADAPT_x+x_tet <= ADAPT_x+x_bonus+7 && ADAPT_y+y_tet >= ADAPT_y+y_bonus && ADAPT_y+y_tet <= ADAPT_y+y_bonus+7))
			{
				sprite8_GRIS(x_bonus, y_bonus, bonus_malus_0[bonus], bonus_malus_1[bonus]);
	      if(compteur != (43+vitesse*10))
	      {
	      	switch(bonus)
	      {
	      	case 0:
	      	vie ++;
	      	draw_num(11, 94, "%02d", vie, 4, GRIS_FONCE, PETIT);
	      	break;
	      	case 1:
	      	vie --;
	      	draw_num(11, 94, "%02d", vie, 4, GRIS_FONCE, PETIT);
	      	break;
	      	case 2:
	      	score += 25;
	      	draw_num(101, 94, "%05u", score, 4, GRIS_FONCE, PETIT);
	      	break;
	      	case 3:
	      	score -= 25;
	      	draw_num(101, 94, "%05u", score, 4, GRIS_FONCE, PETIT);
	      	break;
	      	case 4:
	      	score += 50;
	      	draw_num(101, 94, "%05u", score, 4, GRIS_FONCE, PETIT);
	      	break;
	      	case 5:
	      	score += 100;
	      	draw_num(101, 94, "%05u", score, 4, GRIS_FONCE, PETIT);
	      	break;
	      	case 6:
	      	for(i = 0; i <= 5; i ++)
	      	{
	      		fill_rect(x_qu[i], y_qu[i], x_qu[i]+3, y_qu[i]+3, 2, GRIS_FONCE);
	      	}
	      	for(i = 6; i <= long_qu; i ++)
	      	{
	      		x_qu[i-6] = x_qu[i];
	      		y_qu[i-6] = y_qu[i];
	      	}
	      	long_qu -= 6;
	      	break;
	      	case 7:
	      	allonge += 6;
	      	break;
	      	case 8:
	      	fantome = 0;
	      	break;
	      	case 9:
	      	score += ((12-pom)*(vitesse*2+5));
	      	nivo = ordre == 0? (nivo == 10? 0: nivo+1): random(11);
	    	  vie ++;
	    	  flag = 1;
	    	  goto Debut;
	    	  break;
	      }
	      }
	      compteur = 0;	      
			}		
		}
	
		if(GetPix(ADAPT_x+x_tet+fantome,ADAPT_y+y_tet+fantome) || x_tet == 0 || x_tet == 156 || y_tet == -1 || y_tet == 91)
		{
			if(fantome == 0 && (x_tet == 0 || x_tet == 156 || y_tet == -1 || y_tet == 91))
			{
				switch(x_tet)
				{
					case 0:
					x_tet = 152;
					break;
					case 156:
					x_tet = 4;
					break;
				}
				
				switch(y_tet)
				{
					case -1:
					y_tet = 87;
					break;
					case 91:
					y_tet = 3;
					break;
				}
				
			}
			else
			{
				disp_crash();
				if(-- vie)
				{
					flag = 0;
					goto Debut;
				} 
			}
			
		}
		
		draw_line(x_temps, 92, 157, 92, 0, GRIS_FONCE);
		draw_line(x_temps, 92, 157, 92, 0, GRIS_CLAIR);
		x_temps -= (compteur_t ++)%3 == 0? 1: 0;
		
		if(x_temps == 1)
		{
			disp_message("Time out...");
	    disp_enter();
			if(-- vie)
			{
				flag = 0;
				goto Debut;
			}
			 
		}
				
		for(i = 0;i <= ((11-vitesse)*21); i ++)
		{
			get_key(2);
			if(DROITE && x_coeff != -4)
			{
				x_coeff = 4;
				y_coeff = 0;
				break;
			}
			else if(GAUCHE && x_coeff != 4)
			{
				x_coeff = -4;
				y_coeff = 0;
				break;
			}
			else if(BAS && y_coeff != -4)
			{
				y_coeff = 4;
				x_coeff = 0;
				break;
			}
			else if(HAUT && y_coeff != 4)
			{
				y_coeff = -4;
				x_coeff = 0;
				break;
			}
			else if(ESCAPE)
			{
				disp_quit(&vie);
				break;
			}
			else if(_keytest(RR_DOT))
			{
				QUICK_EXIT_NO_SAVE = 1;
				return;
			}
			else if(_keytest(QUICK_EXIT))
			{
				entry = DerefSym(SymAddMain(SYMSTR("@pythonc"))); // Le symbole '@' rendra cette variable invisible du TIOS (merci Greg Dietsche !)
				Sauvegarde = (unsigned char*)HLock(entry->handle = HeapAlloc(7928));
				*(unsigned short*)Sauvegarde = 7926;
				*(Sauvegarde+7921) = 0;
				strcpy(Sauvegarde+7922, extension);
				*(Sauvegarde+7927) = OTH_TAG;
				memcpy(Sauvegarde+2, plan0, LCD_SIZE);
				memcpy(Sauvegarde+2+LCD_SIZE, plan1, LCD_SIZE);
				memcpy(Sauvegarde+7682, &x_qu, 100);
				memcpy(Sauvegarde+7782, &y_qu, 100);
				*(unsigned short *)(Sauvegarde+7882) = x_coeff;
				*(unsigned short *)(Sauvegarde+7884) = y_coeff;
				*(unsigned short *)(Sauvegarde+7886) = x_tet;
				*(unsigned short *)(Sauvegarde+7888) = y_tet;
				*(unsigned short *)(Sauvegarde+7890) = long_qu;
				*(unsigned short *)(Sauvegarde+7892) = compteur;
				*(unsigned short *)(Sauvegarde+7894) = bonus;
				*(unsigned short *)(Sauvegarde+7896) = allonge;
				*(unsigned short *)(Sauvegarde+7898) = fantome;
				*(unsigned short *)(Sauvegarde+7900) = pom;
				*(unsigned short *)(Sauvegarde+7902) = score;
				*(unsigned short *)(Sauvegarde+7904) = vie;
				*(unsigned short *)(Sauvegarde+7906) = nivo;
				*(unsigned short *)(Sauvegarde+7908) = x_temps;
				*(unsigned short *)(Sauvegarde+7910) = compteur_t;
				*(unsigned short *)(Sauvegarde+7912) = x_pom;
				*(unsigned short *)(Sauvegarde+7914) = y_pom;
				*(unsigned short *)(Sauvegarde+7916) = x_bonus;
				*(unsigned short *)(Sauvegarde+7918) = y_bonus;
				HeapUnlock(entry->handle);
				QUICK_EXIT_SAVE = 1;
				return;
			}
		}
		
		
	}while(vie);
	
	disp_message("Game over...");
	disp_enter();
	
	if(score > high[4].score)
	{
		high_score(score);
	}
	else
	{
		fade_down(1);
		menu_fond();
		menu_scores();
		enter_esc();
	}
}

//////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////
//                     		Fonction appele au lancement du jeu											//
//////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////

void _main(void)
{
	LCD_BUFFER screen;
	LCD_save(screen);
	short y_menu;
	y_menu = 29;
	
	redirige_int();
	EM_moveSymFromExtMem(SYMSTR("pythsav"), HS_NULL); // Dsarchive la variable 'pythsav'
	OuvreFichierSauvegarde();
	
	entry = DerefSym(SymFindMain(SYMSTR("@pythonc")));
	if (entry != NULL)
	{
		Sauvegarde = (unsigned char*)HLock(entry->handle);
		QUICK_EXIT_SAVE = 1;
		goto START_GAME_SAVED;
	}
	
	if(!TI89)
	{
		fade_down(1);
		fond_ecran();
		fade_up();	
	}
	dissolve_SPRITE(intro_0, intro_1);
	get_key(1);
	

	Menu:
	
	fade_down(1);
	menu_fond();
	menu_general();
	fill_rect(41, y_menu, 118, y_menu+9, 2, GRIS_FONCE);
	fade_up();
	
	do
	{
		get_key(1);
	  if(HAUT)
	  {
	  	fill_rect(41, y_menu, 118, y_menu+9, 2, GRIS_FONCE);
	  	y_menu = y_menu == 29? 69: y_menu-10;
	  	fill_rect(41, y_menu, 118, y_menu+9, 2, GRIS_FONCE);
	  }
		if(BAS)
		{
			fill_rect(41, y_menu, 118, y_menu+9, 2, GRIS_FONCE);
	  	y_menu = y_menu == 69? 29: y_menu+10;
	  	fill_rect(41, y_menu, 118, y_menu+9, 2, GRIS_FONCE);
		}
		if(ENTER)
		{
			if(y_menu == 69)
			{
				break;
			}
			else if(y_menu != 29)
			{
				fade_down(2);
			}
			 
			switch(y_menu)
			{
				case 29:
				START_GAME_SAVED:
				jeu();
				if(QUICK_EXIT_NO_SAVE || QUICK_EXIT_SAVE)
				{
					goto FIN_DU_JEU;
				}
				goto Menu;
				case 39:
				menu_options();
				goto Menu;
				case 49:
				menu_scores();
				enter_esc();
				goto Menu;
				case 59:
				menu_apropos();
				if(ENTER)
				{
					menu_bonus();
					if(ENTER)
					{
						menu_malus();
					}
				}
				goto Menu;
			}
		}
	}while(!ESCAPE);
	
	FIN_DU_JEU:
	FermeFichierSauvegarde();
	if(!QUICK_EXIT_SAVE)					// On efface la variable '@pythonc' si on n'a
	{															// pas appuy sur [HOME] pendant le jeu.
		SymDel(SYMSTR("@pythonc"));
	}
	if(QUICK_EXIT_SAVE || QUICK_EXIT_NO_SAVE)
	{
		memcpy(plan0, screen, LCD_SIZE);
		memcpy(plan1, screen, LCD_SIZE);
	}
	else
	{
		dissolve_LCD(screen, screen);
	}
	restaure_int();
	ST_helpMsg("Pythonc by Nul v1.00");
	EM_moveSymToExtMem(SYMSTR("pythsav"), HS_NULL); // Archive la variable 'pythsav'
	GKeyFlush();	// Permet de ne pas relancer le programme lorsqu'on est revenu dans HOME
}

//////////////////////////////////////////////////////////////////////////////////////
