//////////////////////////////////////////////////////////////////////////////////////
//																				      																		//
//				Dfinition des menus gnral, des options, des scores, d'information,des	//
//				bonus, des malus et le programme des highscores.													//
//																																									//
//////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////

void menu_fond(void)
{
	register short i;
	
	bitmap_put(2, 2, pyth_gros_p, 4, GRIS_CLAIR);
	bitmap_put(3, 3, pyth_gros_p, 4, GRIS_FONCE);
	bitmap_put(17, 84, copyright_p, 4, GRIS_FONCE);
	bitmap_put(18, 85, copyright_p, 4, GRIS_CLAIR);
	fill_rect(0, 82, 159, 99, 2, GRIS_CLAIR);
	fill_rect(0, 82, 159, 99, 2, GRIS_FONCE);
	draw_rect(0, 0, 159, 82, 4, GRIS_FONCE);
	draw_rect(0, 0, 159, 82, 4, GRIS_CLAIR);
	draw_rect(1, 1, 158, 82, 4, GRIS_FONCE);
	draw_line(0, 24, 159, 24, 4, GRIS_FONCE);
	draw_line(0, 25, 159, 25, 4, GRIS_CLAIR);
	draw_line(0,25, 159, 25, 4, GRIS_FONCE);
	
	for(i = 28; i <= 78; i += 6)
	{
		sprite8_GRIS(4, i, pom_0, pom_1);
		sprite8_GRIS(12, i, pom_0, pom_1);
		sprite8_GRIS(144, i, pom_0, pom_1);
		sprite8_GRIS(152, i, pom_0, pom_1);
	}
}

//////////////////////////////////////////////////////////////////////////////

void menu_general(void)
{
	fill_rect(18, 24, 38, 82,4, GRIS_FONCE);
	fill_rect(121, 24, 141, 82,4, GRIS_FONCE);
	bitmap_put(60, 30, jouer_p, 4, GRIS_CLAIR);
	bitmap_put(45, 40, options_p, 4, GRIS_CLAIR);
	bitmap_put(49, 50, scores_p, 4, GRIS_CLAIR);
	bitmap_put(54, 60, apropos_p, 4, GRIS_CLAIR);
	bitmap_put(59, 70, quitter_p, 4, GRIS_CLAIR);
	bitmap_put(61, 31, jouer_p, 4, GRIS_FONCE);
	bitmap_put(46, 41, options_p, 4, GRIS_FONCE);
	bitmap_put(50, 51, scores_p, 4, GRIS_FONCE);
	bitmap_put(55, 61, apropos_p, 4, GRIS_FONCE);
	bitmap_put(60, 71, quitter_p, 4, GRIS_FONCE);
}

//////////////////////////////////////////////////////////////////////////////////////

void menu_options(void)
{
	short y_options;
	
	y_options = 51;
	
	fill_rect(18, 24, 28, 82, 4, GRIS_FONCE);
	fill_rect(131, 24, 141, 82, 4, GRIS_FONCE);
	bitmap_put(45, 26, options_p, 4, GRIS_CLAIR);
	bitmap_put(46, 27, options_p, 4, GRIS_FONCE);
	fill_rect(29, 26, 130, 34, 2, GRIS_FONCE);
	fill_rect(30, 36, 129, 80, 4, GRIS_CLAIR);
	draw_str(51, 39, "Levels:", 2, GRIS_CLAIR, GROS);
	draw_str(52, 40, "Levels:", 2, GRIS_FONCE, GROS);
	draw_str(44, 53, ordre == 0?"Normal order": "Random order", 4, GRIS_FONCE, NORMAL);
	sprite8_GRIS(34, 53,gauche1_0, gauche1_1);
	sprite8_GRIS(122, 53,droite1_0, droite1_1);
	draw_str(40, 65, "Speed:", 2, GRIS_CLAIR, GROS);
	draw_str(41, 66, "Speed:", 2, GRIS_FONCE, GROS);
	draw_num(96, 66, "%02d", vitesse, 4, GRIS_FONCE, GROS);
	sprite16_GRIS(87, 66, gauche2_0, gauche2_1);
	sprite16_GRIS(114, 66, droite2_0, droite2_1);
	
	fill_rect(31, y_options, 128, y_options+10, 2, GRIS_CLAIR);
	fill_rect(31, y_options, 128, y_options+10, 2, GRIS_FONCE);
	fade_up();
	
	do
	{
		get_key(1);
		
		if(y_options == 51)
		{
			if(DROITE || GAUCHE)
			{
				draw_str(44, 53, ordre == 0? "Normal": "Random", 2, GRIS_FONCE, NORMAL);
				ordre = ordre == 0? 1: 0;
			  draw_str(44, 53, ordre == 0? "Normal": "Random", 2, GRIS_FONCE, NORMAL);
			}
			
		}
		
		if(y_options == 65)
		{
			if(DROITE)
			{
				draw_num(96, 66, "%02d", vitesse, 2, GRIS_FONCE, GROS);
				vitesse = vitesse == 10? 1: vitesse+1;
				draw_num(96, 66, "%02d", vitesse, 2, GRIS_FONCE, GROS);
			}
			else if(GAUCHE)
			{
				draw_num(96, 66, "%02d", vitesse, 2, GRIS_FONCE, GROS);
				vitesse = vitesse == 1? 10: vitesse-1;
				draw_num(96, 66, "%02d", vitesse, 2, GRIS_FONCE, GROS);
			}
		}
		
		if(BAS || HAUT)
		{
	    fill_rect(31, y_options, 128,y_options+10, 2, GRIS_FONCE);
	    fill_rect(31, y_options, 128,y_options+10, 2, GRIS_CLAIR);
			y_options = y_options == 51? 65: 51;
			fill_rect(31, y_options, 128,y_options+10, 2, GRIS_CLAIR);
			fill_rect(31, y_options, 128,y_options+10, 2, GRIS_FONCE);
		}
	}while(!ESCAPE && !ENTER);
	
}

//////////////////////////////////////////////////////////////////////////////////////

void menu_scores(void)
{
	register short i;
	
	fill_rect(18, 24, 24, 82, 4, GRIS_FONCE);
	fill_rect(135, 24, 141, 82, 4, GRIS_FONCE);
	bitmap_put(49, 26, scores_p, 4, GRIS_CLAIR);
	bitmap_put(49, 27, scores_p, 4, GRIS_FONCE);
	fill_rect(25, 26, 134, 34, 2, GRIS_FONCE);
	fill_rect(26, 36, 133, 80, 4, GRIS_CLAIR);
	
	for(i = 0; i < 5; i ++)
	{
		draw_str(26, 37+i*9, high[i].nom, 4, GRIS_FONCE, NORMAL);
		draw_num(104, 37+i*9, "%05d", high[i].score, 4, GRIS_FONCE, NORMAL);
	}
	
	fade_up();
	
}

//////////////////////////////////////////////////////////////////////////////////////

void menu_apropos(void)
{
	fill_rect(18, 24, 24, 82, 4, GRIS_FONCE);
	fill_rect(135, 24, 141, 82, 4, GRIS_FONCE);
	bitmap_put(54, 26, apropos_p, 4, GRIS_CLAIR);
	bitmap_put(55, 27, apropos_p, 4, GRIS_FONCE);
	fill_rect(25, 26, 134, 34, 2, GRIS_FONCE);
	fill_rect(26, 36, 133, 80, 4, GRIS_CLAIR);
	draw_str(45, 37, "Compiled with TIGCC", 4, 2, PETIT);
	draw_str(50, 45, "Date: 05/09/2005", 4, GRIS_FONCE, PETIT);
	draw_str(30, 52, "version 1.00", 2, GRIS_CLAIR, GROS);
	draw_str(31, 53, "version 1.00", 2, GRIS_FONCE, GROS);
	draw_str(58, 64, "E-mail:", 4, GRIS_FONCE, NORMAL);
	draw_line(59, 72, 97, 72, 2, GRIS_CLAIR);
	draw_line(59, 72, 97, 72, 2, GRIS_FONCE);
	draw_str(27, 75, "olivier_givaudan@hotmail.com", 4, GRIS_FONCE, PETIT);
	fade_up();
	enter_esc();
}

//////////////////////////////////////////////////////////////////////////////////////

void menu_bonus(void)
{
	fade_down(2);
	fill_rect(18, 24, 24, 82, 4, GRIS_FONCE);
	fill_rect(135, 24, 141, 82, 4, GRIS_FONCE);
	bitmap_put(55, 26, bonus_p, 4, GRIS_CLAIR);
	bitmap_put(56, 27, bonus_p, 4, GRIS_FONCE);
	fill_rect(25, 26, 134, 34, 2, GRIS_FONCE);
	fill_rect(26, 36, 133, 80, 4, GRIS_CLAIR);
	fill_rect(27, 37, 36, 46, 2, GRIS_CLAIR);
	fill_rect(27, 48, 36, 57, 2, GRIS_CLAIR);
	fill_rect(27, 59, 36, 68, 2, GRIS_CLAIR);
	fill_rect(27, 70, 36, 79, 2, GRIS_CLAIR);
	fill_rect(86, 39, 95, 48, 2, GRIS_CLAIR);
	fill_rect(86, 53, 95, 62, 2, GRIS_CLAIR);
	fill_rect(86, 67, 95, 76, 2, GRIS_CLAIR);
	sprite8_GRIS(28, 38, bonus_malus_0[0], bonus_malus_1[0]);
	sprite8_GRIS(28, 49, bonus_malus_0[2], bonus_malus_1[2]);
	sprite8_GRIS(28, 60, bonus_malus_0[4], bonus_malus_1[4]);
	sprite8_GRIS(28, 71, bonus_malus_0[5], bonus_malus_1[5]);
	sprite8_GRIS(87, 40, bonus_malus_0[6], bonus_malus_1[6]);
	sprite8_GRIS(87, 54, bonus_malus_0[8], bonus_malus_1[8]);
	sprite8_GRIS(87, 68, bonus_malus_0[9], bonus_malus_1[9]);
	draw_str(38, 40, "+ 1 life", 4, GRIS_FONCE, PETIT);
	draw_str(38, 51, "+ 25 points", 4, GRIS_FONCE, PETIT);
	draw_str(38, 62, "+ 50 points", 4, GRIS_FONCE, PETIT);
	draw_str(38, 73, "+ 100 points", 4, GRIS_FONCE, PETIT);
	draw_str(97, 39, "Shrinks", 4, GRIS_FONCE, PETIT);
	draw_str(97, 45, "the snake", 4, GRIS_FONCE, PETIT);
	draw_str(97, 55, "Ghost!", 4, GRIS_FONCE, PETIT);
	draw_str(97, 67, "Completes", 4, GRIS_FONCE, PETIT);
	draw_str(97, 73, "the level", 4, GRIS_FONCE, PETIT);
	fade_up();
	enter_esc();
}

//////////////////////////////////////////////////////////////////////////////////////

void menu_malus(void)
{
	fade_down(2);
	fill_rect(18, 24, 24, 82, 4, GRIS_FONCE);
	fill_rect(135, 24, 141, 82, 4, GRIS_FONCE);
	bitmap_put(55, 26, malus_p, 4, GRIS_CLAIR);
	bitmap_put(56, 27, malus_p, 4, GRIS_FONCE);
	fill_rect(25, 26, 134, 34, 2, GRIS_FONCE);
	fill_rect(26, 36, 133, 80, 4, GRIS_CLAIR);
	fill_rect(51, 39, 60, 48, 2, GRIS_CLAIR);
	fill_rect(51, 53, 60, 62, 2, GRIS_CLAIR);
	fill_rect(51, 67, 60, 76, 2, GRIS_CLAIR);
	sprite8_GRIS(52, 40, bonus_malus_0[1], bonus_malus_1[1]);
	sprite8_GRIS(52, 54, bonus_malus_0[3], bonus_malus_1[3]);
	sprite8_GRIS(52, 68, bonus_malus_0[7], bonus_malus_1[7]);
	draw_str(62, 42, "- 1 life", 4, GRIS_FONCE, PETIT);
	draw_str(62, 56, "- 25 points", 4, GRIS_FONCE, PETIT);
	draw_str(62, 70, "Elarges the snake", 4, GRIS_FONCE, PETIT);
	fade_up();
	enter_esc();
}

//////////////////////////////////////////////////////////////////////////////////////

void high_score(unsigned short score)
{
	register short i;
	char lcd[2*LCD_SIZE];
	char nom[] = "           ";
	short key;
	short dim;
	
	dim = 0;
	
	for(i = 4; high[i-1].score < score&&i; i --)
	{
		memcpy(&high[i], &high[i-1], sizeof(HIGH_SCORES));
	}
    
	high[i].score = score;
	
	restaure_int();
	GrayOn();
	fade_down(1);
	if(!TI89)
	{
		fond_ecran();
		clr_plans();
	}
	menu_fond();
	menu_scores();
	fill_rect(0, 84, 159, 99, 4, GRIS_CLAIR);
	fill_rect(0, 84, 159, 99, 4, GRIS_FONCE);
	fill_rect(0, 85, 159, 96, 0, GRIS_FONCE);
	fill_rect(0, 85, 159, 96, 4, GRIS_CLAIR);
	draw_str(23, 86, "New Highscore!", 2, GRIS_CLAIR, GROS);
	draw_str(24, 87, "New Highscore!", 2, GRIS_FONCE, GROS);
	sprite8_GRIS(20, 37+i*9, droite1_0, droite1_1);
	GKeyFlush();
	
	do
	{
		
		draw_str(26, 37+i*9, nom, 4, GRIS_FONCE, NORMAL);
		key = ngetchx();
		
		if(key >= 18 && key <= 255 && dim < 11)
		{
			nom[dim ++] = key;
		}
		else if(key == KEY_BACKSPACE && dim > 0)
		{
			nom[-- dim] = ' ';
		}
		else if(key == KEY_CLEAR)
		{
			memset(nom, ' ', 12);
			dim = 0;
		}
		else if(key == KEY_APPS)
		{
			off();
		}

	}while(key != KEY_ENTER);
	
	sprite8_GRIS(20, 37+i*9, droite1_0, droite1_1);
	fill_rect(0, 84, 159, 99, 4, GRIS_FONCE);
	fill_rect(0, 84, 159, 99, 4, GRIS_CLAIR);
	bitmap_put(17, 84, copyright_p, 2, GRIS_CLAIR);
	bitmap_put(18, 85, copyright_p, 2, GRIS_FONCE);
	sauve_pic(lcd);
	strcpy(high[i].nom, nom);
	GrayOff();
	redirige_int();
	restaure_pic(lcd);
	get_key(2);
	enter_esc();
}

//////////////////////////////////////////////////////////////////////////////////////